# generated by datamodel-codegen:
#   filename:  <stdin>
#   timestamp: 2023-02-17T08:34:50+00:00

from __future__ import annotations

import uuid
import datetime
from enum import Enum
from typing import Any, Literal

from pydantic import BaseModel, Extra, Field, conint, constr


class Assigned(Enum):
    unassigned = 'unassigned'
    admin = 'admin'


class WarningItem(BaseModel):
    message: str | None = None
    data: dict[str, Any] | None = None
    code: int | None = None


class Meta(BaseModel):
    class Config:
        extra = Extra.forbid

    id: uuid.UUID | None = None
    type: str | None = None
    version: constr(regex=r'(\d+)\.(\d+)') | None = None
    manufacturer: uuid.UUID | Assigned | None = None
    owner: uuid.UUID | Assigned | None = None
    created: datetime.datetime | Literal['not_available'] | None = None
    updated: datetime.datetime | Literal['not_available'] | None = None
    changed: datetime.datetime | Literal['not_available'] | None = None
    application: uuid.UUID | None = None
    revision: int | None = None
    trace: str | None = None
    oem: str | None = None
    deprecated: bool | None = None
    redirect: constr(regex=r'^[0-9a-zA-Z_-]+$', min_length=1, max_length=200) | None = None
    size: int | None = None
    path: str | None = None
    parent: uuid.UUID | None = None
    error: dict[str, Any] | None = None
    icon: str | None = None
    tag: list[constr(min_length=2, max_length=20)] | None = None
    tag_by_user: list[constr(min_length=2, max_length=20)] | None = None
    name_by_user: constr(max_length=100) | None = None
    warning: list[WarningItem] | None = None
    parent_name: dict[str, Any] | None = None
    read_only: bool | None = None
    original_id: uuid.UUID | None = None
    alert: list[uuid.UUID] | None = None
    contract: list[uuid.UUID] | None = None


class Subscription(BaseModel):
    price_id: uuid.UUID | None = None
    subscription_id: uuid.UUID | None = None
    free: bool | None = None
    dependant_of: uuid.UUID | None = None
    extra: conint(ge=0) | None = None
    created: datetime.datetime | None = None
    current_period_start: datetime.datetime | None = None
    current_period_end: datetime.datetime | None = None


class ScheduledSubscription(BaseModel):
    price_id: uuid.UUID | None = None
    subscription_id: uuid.UUID | None = None
    free: bool | None = None
    extra: conint(ge=0) | None = None
    next_period_start: datetime.datetime | None = None


class Card(BaseModel):
    active: bool | None = None
    country: str | None = None
    last4: str | None = None
    brand: str | None = None


class Purse(BaseModel):
    class Config:
        extra = Extra.forbid

    meta: Meta = Field(..., title='meta-2.1')
    currency: str | None = None
    subscription: Subscription
    scheduled_subscription:  ScheduledSubscription | None = None
    card:  Card | None = None
